--[[--------------------------------------------------------------------------------------------------
SUBVENTION
------------------------------------------------------------------------------------------------------
file: subventionModule
author:	Team LTW
start project: 07.12.2017 
------------------------------------------------------------------------------------------------------
Farming Simulator 17
V1.0.0.0 - 06.11.2018

Farming Simulator 19
V1.0.0.0 - 16.05.2019
------------------------------------------------------------------------------------------------------
copyright (c) Team LTW
----------------------------------------------------------------------------------------------------]]
subvention = {}

function subvention:getOwnedFieldSize()
	local fields = 0
	fields = g_farmlandManager.farmlands
	local fieldSize = 0	
	local i = 1
	while i <= #fields do
		if fields[i] ~= nil then
			if fields[i].isOwned == true and g_farmlandManager.farmlandMapping[i] == financeExtent.farmId then
				local fieldArea = fields[i].areaInHa
				if fieldArea > 0 then
					fieldSize = fieldSize + fieldArea
				end
			end
		end	
		i = i + 1
	end
	fieldSize = (math.ceil(fieldSize * 10)) / 10
	return fieldSize
end;

function subvention:getSubventionAmount()
	local basicPremium = financeExtent.basicPremium;
	local greening = financeExtent.greening;
	local firstHa = financeExtent.firstHa;		--first 30ha
	local furtherHa = financeExtent.furtherHa;		--further 16ha
	local youngFarmer = financeExtent.youngFarmer;
	local currentDay = g_currentMission.environment.currentDay;
	
	local ownedFieldSize = 0;
	ownedFieldSize = self:getOwnedFieldSize();
--print("ownedFieldSize: "..tostring(ownedFieldSize));
			
	local amountBasic = 0;		
	amountBasic = (basicPremium + greening) * ownedFieldSize;
--print("amountBasic: "..tostring(amountBasic));
	
	local amountFirstHa = 0;
	local amountFurtherHa = 0;
	local amountSmallFarmer = 0;	
	if ownedFieldSize <= 95 then
		if ownedFieldSize <= 30 then
			amountFirstHa = firstHa * ownedFieldSize;
		end;
		if ownedFieldSize > 30 and ownedFieldSize <= 46 then
			amountFurtherHa = furtherHa * (ownedFieldSize - 30)
		end;	
		amountSmallFarmer = amountFirstHa + amountFurtherHa;
	end;
--print("amountSmallFarmer: "..tostring(amountSmallFarmer));
	
	local amountYoungFarmer = 0;
	if ownedFieldSize <= 90 and currentDay <= 20 then
		amountYoungFarmer = youngFarmer * ownedFieldSize;
	end;

		
--print("amountYoungFarmer: "..tostring(amountYoungFarmer));
	
	local subventionAmount = 0;
	subventionAmount = amountBasic + amountSmallFarmer + amountYoungFarmer;
--print("subventionAmount:"..tostring(subventionAmount));

	return subventionAmount;
end;

function subvention:difficulty()
	local subvention = 0;
	local difficulty = g_currentMission.missionInfo.difficulty;
	
	if difficulty == 1 then
		subvention = (math.floor((self:getSubventionAmount() * 1.9) * 100)) / 100;
	elseif difficulty == 2 then
		subvention = (math.floor((self:getSubventionAmount() * 1.5) * 100)) / 100;
	elseif difficulty == 3 then
		subvention = (math.floor((self:getSubventionAmount() * 100))) / 100;
	end;
--print("subvention: "..tostring(subvention));
	return subvention;
end;

function subvention:enablePayTime()
	if g_currentMission.environment.currentHour == 15 then
		return true
	end
	return false
end;

function subvention:payTime()
	if g_currentMission.environment.currentHour == 16 then	
		return true;
	end;
	return false;
end;